import { Injectable } from '@angular/core';
import { ServiceProvider } from '<%= resolveRelativePath('src/app/api/service.provider', generateFilePathForApi(`api/${dasherize(name)}/${dasherize(name)}.service.ts`)) %>';
import { catchError, tap, map } from 'rxjs/operators';
import { Observable } from 'rxjs/Observable';
import <%= resolveModelName() %> from '<%= resolveRelativePath(`src/app/models/${resolveModelName()}`, generateFilePathForApi(`api/${dasherize(name)}/${dasherize(name)}.service.ts`)) %>';

@Injectable()
export class <%= classify(name) %>Service extends ServiceProvider {
  public url = '/api/admin/users';
  public model = <%= resolveModelName() %>;

  profile(params: {}): Observable<any> {
    const meUrl = '/api/me';
    return this.http.get(this.apiUrl.getApiUrl(meUrl), { params }).pipe(
      map(result => new User((result as any).data)),
      catchError(error => {
        throw error;
      })
    );
  }

  changeStatus(id, params): Observable<any> {
    return this.http.put(`${this.apiUrl.getApiUrl(this.url)}/status/${id}`, params).pipe(
      map(result => {
        return new User((result as any).data);
      }),
      catchError(error => {
        throw error;
      })
    );
  }

  attachRoleToUser(userId, roleId): Observable<any> {
    return this.http
      .put(this.apiUrl.getApiUrl(this.url) + `/${userId}/role`, {
        role_id: roleId
      })
      .pipe(
        tap(result => {}),
        catchError(error => {
          throw error;
        })
      );
  }

  detachRoleFromUser(data): Observable<any> {
    return this.http.delete(this.apiUrl.getApiUrl(this.url) + `/${data.userId}/role/${data.roleId}`).pipe(
      tap(result => {}),
      catchError(error => {
        throw error;
      })
    );
  }

  saveRoleUser(userId, roles): Observable<any> {
    return this.http.put(this.apiUrl.getApiUrl(this.url) + `/${userId}/roles`, roles).pipe(
      tap(result => {}),
      catchError(error => {
        throw error;
      })
    );
  }
}
