import * as _ from 'lodash';
import { <%= actionGenerator('CREATE', 'REQUESTED') %>, <%= actionGenerator('CREATE', 'SUCCESSED') %>, <%= actionGenerator('RENDER_CREATE_FORM', 'REQUESTED') %>, <%= actionGenerator('UPDATE', 'INPUT_OPTION') %> } from './create.actions';
import { Router } from '@angular/router';
import { put, takeEvery, takeLatest, call } from 'redux-saga/effects';
import { API_CALL_ERROR } from '<%= resolveRelativePath('src/app/store/action', generateFilePath(`${dasherize(name)}/create/create.saga.ts`)) %>';
import { ApiService } from '<%= resolveRelativePath('src/app/api/api.service', generateFilePath(`${dasherize(name)}/create/create.saga.ts`)) %>';
import { AppInjector } from '<%= resolveRelativePath('src/app/app-injector', generateFilePath(`${dasherize(name)}/create/create.saga.ts`)) %>';

import { listUserRouter } from '../<%= dasherize(name) %>.const';
<%if(usermanagementwithrole === true || usermanagementwithrole === 'true'){ %>
import { fetchAllRoles } from '../../../acl/roles/roles.saga';
<% } %>

function* watchCreateAdminUserRequest() {
  yield takeEvery(<%= actionGenerator('CREATE', 'REQUESTED') %>, function*(action: any) {
    const router = AppInjector.get(Router);
    try {
      let result = yield AppInjector.get(ApiService)
        .admin.user.create(action.data)
        .toPromise();
      yield put({ type: <%= actionGenerator('CREATE', 'SUCCESSED') %>, data: result });
      router.navigate(listUserRouter());
    } catch (e) {
      yield put({ type: API_CALL_ERROR, error: e });
    }
  });
}


<%if(usermanagementwithrole === true || usermanagementwithrole === 'true'){ %>

function* watchAdminCreateUserFormRender() {
    yield takeLatest(<%= actionGenerator('RENDER_CREATE_FORM', 'REQUESTED') %>, function*() {
    const roles = yield call(fetchAllRoles);
    yield put({
      type: <%= actionGenerator('UPDATE', 'INPUT_OPTION') %>,
      input: 'role',
      data: _.map(roles, (item, key) => _.assign(item, { value: item.slug, label: item.name, selected: key === 0 }))
    });
  }
}
export default [watchCreateAdminUserRequest, watchAdminCreateUserFormRender];
<% } else {%>
export default [watchCreateAdminUserRequest];
<% } %>

