import { put, select, takeLatest, call } from 'redux-saga/effects';
import * as _ from "lodash";
import list from "./list/list.saga";
import edit from "./edit/edit.saga";
import create from "./create/create.saga";
import { <%= actionGenerator('GET_ALL', 'REQUESTED') %>, <%= actionGenerator('GET_ALL', 'SUCCESSED') %> } from './<%= dasherize(name) %>.action';
import { API_CALL_ERROR } from '<%= resolveRelativePath('src/app/store/action', generateFilePath(`${dasherize(name)}/${dasherize(name)}.saga.ts`)) %>';
import { ApiService } from '<%= resolveRelativePath('src/app/api/api.service', generateFilePath(`${dasherize(name)}/${dasherize(name)}.saga.ts`)) %>';
import { AppInjector } from '<%= resolveRelativePath('src/app/app-injector', generateFilePath(`${dasherize(name)}/${dasherize(name)}.saga.ts`)) %>';


export function* fetchAll<%= pluralizeName(classify) %>() {
  const fetched = yield select((state) => (state as any).<%= fullReducerGenerator('all') %>.fetched);
  if (!fetched) {
    try {
      const api = AppInjector.get(ApiService);
      let result = yield api.<%= resolveApiModule() %>.list().toPromise();
      return result;
    } catch (e) {
      yield put({ type: API_CALL_ERROR, error: e });
    }
  } else {
    const data = yield select(state => (state as any).<%= fullReducerGenerator('all') %>.items);
    return data;
  }
}


function* allSaga(action) {
  const data = yield call(fetchAll<%= pluralizeName(classify) %>);
  yield put({type: <%= actionGenerator('GET_ALL', 'SUCCESSED') %>, component: action.component, data: data});
}

function* watchFetchAll<%= pluralizeName(classify) %>Request() {
  yield takeLatest(<%= actionGenerator('GET_ALL', 'REQUESTED') %>, allSaga);
}
export default [...list, ...edit, ...create, watchFetchAll<%= pluralizeName(classify) %>Request];
