import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Store } from '<%= resolveRelativePath('src/app/store/store.module', generateFilePath(`${dasherize(name)}/create/create.component.ts`)) %>';
import { <%= routerGenerator('list')%> } from '../<%= dasherize(name) %>.const';
import { AppInjector } from '<%= resolveRelativePath('src/app/app-injector', generateFilePath(`${dasherize(name)}/create/create.component.ts`)) %>';
import { <%= actionGenerator('RENDER_CREATE', 'REQUESTED') %>, <%= actionGenerator('CREATE', 'REQUESTED') %> } from './create.actions';
import { InputBase, TextBox } from '@vicoders/reactive-form';
import { BaseComponent } from '<%= resolveRelativePath('src/app/components/base.component', generateFilePath(`${dasherize(name)}/create/create.component.ts`)) %>';


@Component({
  selector: 'app-create',
  templateUrl: './create.component.html',
  styleUrls: ['./create.component.scss']
})
export class CreateComponent extends BaseComponent implements OnInit {
  public reducer: String = '<%= fullReducerGenerator('create') %>';
  public <%= routerGenerator('list')%>: Function = <%= routerGenerator('list')%>;
  public activatedRoute;

  constructor(activatedRoute: ActivatedRoute) {
    super();
    this.activatedRoute = activatedRoute;
  }

  ngOnInit() {
    this.init();

    let inputs: InputBase<any>[] = [
      new TextBox({
        key: 'name',
        label: 'Name',
        required: true,
        classes: ['col'],
        group_classes: ['col-12'],
        order: 1
      })
    ];
    this.store.dispatch({ type: <%= actionGenerator('RENDER_CREATE', 'REQUESTED') %>, data: { inputs: inputs } });
  }

  onSubmit(form) {
    if (form.valid) {
      const store = AppInjector.get(Store).getInstance();
      store.dispatch({ type: <%= actionGenerator('CREATE', 'REQUESTED') %>, data: form.value });
    }
  }

  mapStateToProps(state) {
    return {
      payload: state.<%= fullReducerGenerator('create') %>
    };
  }

  mapDispatchToProps(dispatch) {
    return {
      dispatch
    };
  }
}
