import { <%= actionGenerator('CREATE', 'REQUESTED') %>, <%= actionGenerator('CREATE', 'SUCCESSED') %>} from './create.actions';
import { Router } from '@angular/router';
import { put, takeEvery } from 'redux-saga/effects';
import { <%= routerGenerator('list')%> } from '../<%= dasherize(name) %>.const';
import { API_CALL_ERROR } from '<%= resolveRelativePath('src/app/store/action', generateFilePath(`${dasherize(name)}/create/create.saga.ts`)) %>';
import { ApiService } from '<%= resolveRelativePath('src/app/api/api.service', generateFilePath(`${dasherize(name)}/create/create.saga.ts`)) %>';
import { AppInjector } from '<%= resolveRelativePath('src/app/app-injector', generateFilePath(`${dasherize(name)}/create/create.saga.ts`)) %>';

function* watchCreate<%= classify(name) %>Request() {
  yield takeEvery(<%= actionGenerator('CREATE', 'REQUESTED') %>, function* (action: any) {
    const router = AppInjector.get(Router);
    try {
      let result = yield AppInjector.get(ApiService).<%= resolveApiModule() %>.create(action.data).toPromise();
      yield put({ type: <%= actionGenerator('CREATE', 'SUCCESSED') %>, data: result });
      router.navigate(<%= routerGenerator('list')%>());
    } catch (e) {
      yield put({ type: API_CALL_ERROR, error: e });
    }
  });
}

export default [watchCreate<%= classify(name) %>Request];
