import * as _ from 'lodash';
import { <%= actionGenerator('EDIT', 'REQUESTED') %>, <%= actionGenerator('RENDER_EDIT', 'FORM_REQUESTED') %> } from './edit.actions';
import { ActivatedRoute } from '@angular/router';
import { Component, OnInit } from '@angular/core';
import { <%= routerGenerator('list')%> } from '../<%= dasherize(name) %>.const';
import { Store } from '<%= resolveRelativePath('src/app/store/store.module', generateFilePath(`${dasherize(name)}/edit/edit.component.ts`)) %>';
import { AppInjector } from '<%= resolveRelativePath('src/app/app-injector', generateFilePath(`${dasherize(name)}/edit/edit.component.ts`)) %>';
import { InputBase, TextBox } from '@vicoders/reactive-form';
import { BaseComponent } from '<%= resolveRelativePath('src/app/components/base.component', generateFilePath(`${dasherize(name)}/edit/edit.component.ts`)) %>';

@Component({
  selector: 'app-edit',
  templateUrl: './edit.component.html',
  styleUrls: ['./edit.component.scss']
})
export class EditComponent extends BaseComponent implements OnInit {
  public reducer: String = '<%= fullReducerGenerator('edit') %>';
  public <%= routerGenerator('list')%>: Function = <%= routerGenerator('list')%>;
  constructor(private activatedRoute: ActivatedRoute) {
    super();
    this.activatedRoute = activatedRoute;
  }

  ngOnInit() {
    this.init();

    let inputs: InputBase<any>[] = [
      new TextBox({
        key: 'name',
        label: 'Name',
        required: true,
        classes: ['col'],
        group_classes: ['col-12'],
        order: 1
      })
    ];
    this.dispatch({ type: <%= actionGenerator('RENDER_EDIT', 'FORM_REQUESTED') %>, data: { id: this.activatedRoute.snapshot.params.id, inputs: inputs } });
  }

  onSubmit(form) {
    const store = AppInjector.get(Store).getInstance();
    if (form.valid) {
      store.dispatch({
        type: <%= actionGenerator('EDIT', 'REQUESTED') %>,
        data: _.assign(form.value),
        id: store.getState().<%= fullReducerGenerator('edit') %>.item.id
      });
    }
  }

  getItemId() {
    return this.activatedRoute.snapshot.params.id;
  }

  mapStateToProps(state) {
    return {
      payload: state.<%= fullReducerGenerator('edit') %>
    };
  }

  mapDispatchToProps(dispatch) {
    return {
      dispatch
    };
  }
}
