import { Router } from '@angular/router';
import { <%= actionGenerator('FETCH_ALL', 'REQUESTED') %> } from './../list/list.actions';
import {
  <%= actionGenerator('DELETE', 'REQUESTED') %>,
  <%= actionGenerator('GET', 'REQUESTED') %>,
  <%= actionGenerator('GET', 'SUCCESSED') %>,
  <%= actionGenerator('EDIT', 'REQUESTED') %>,
  <%= actionGenerator('RENDER_EDIT', 'FORM_REQUESTED') %>,
  <%= actionGenerator('FILL', 'DETAIL_FORM') %>
} from './edit.actions';
import { takeEvery, put, takeLatest } from 'redux-saga/effects';
import { <%= routerGenerator('list')%> } from '../<%= dasherize(name) %>.const';
import { API_CALL_ERROR } from '<%= resolveRelativePath('src/app/store/action', generateFilePath(`${dasherize(name)}/edit/edit.saga.ts`)) %>';
import { ApiService } from '<%= resolveRelativePath('src/app/api/api.service', generateFilePath(`${dasherize(name)}/edit/edit.saga.ts`)) %>';
import { AppInjector } from '<%= resolveRelativePath('src/app/app-injector', generateFilePath(`${dasherize(name)}/edit/edit.saga.ts`)) %>';

function* watchEdit<%= classify(name) %>Request() {
  yield takeEvery(<%= actionGenerator('EDIT', 'REQUESTED') %>, function* (action: any) {
    const router = AppInjector.get(Router);
    try {
      let result = yield AppInjector.get(ApiService).<%= resolveApiModule() %>.update(action.id, action.data).toPromise();
      router.navigate(<%= routerGenerator('list')%>());
    } catch (e) {
      yield put({ type: API_CALL_ERROR, error: e });
    }
  });
}

function* watchGet<%= classify(name) %>Request() {
  yield takeEvery(<%= actionGenerator('GET', 'REQUESTED') %>, function* (action: any) {
    try {
      let result = yield AppInjector.get(ApiService).<%= resolveApiModule() %>.getItemById(action.data).toPromise();
      yield put({ type: <%= actionGenerator('GET', 'SUCCESSED') %>, data: result });
    } catch (e) {
      yield put({ type: API_CALL_ERROR, error: e });
    }
  });
}

function* watchDelete<%= classify(name) %>Request() {
  yield takeEvery(<%= actionGenerator('DELETE', 'REQUESTED') %>, function* (action: any) {
    try {
      yield AppInjector.get(ApiService).<%= resolveApiModule() %>.delete(action.data).toPromise();
      yield put({ type: <%= actionGenerator('FETCH_ALL', 'REQUESTED') %> });
    } catch (e) {
      yield put({ type: API_CALL_ERROR, error: e });
    }
  });
}

function* watchRender<%= classify(name) %>DetailFormRequested() {
  yield takeLatest(<%= actionGenerator('RENDER_EDIT', 'FORM_REQUESTED') %>, function*(action: any) {
    yield put({ type: <%= actionGenerator('GET', 'REQUESTED') %>, data: action.data.id });
  });
}

function* watchFetch<%= classify(name) %>DetailSuccessed() {
  yield takeLatest(<%= actionGenerator('GET', 'SUCCESSED') %>, function* (action: any) {
    yield put({ type: <%= actionGenerator('FILL', 'DETAIL_FORM') %>, data: action.data });
  });
}

export default [watchEdit<%= classify(name) %>Request, watchGet<%= classify(name) %>Request, watchDelete<%= classify(name) %>Request, watchRender<%= classify(name) %>DetailFormRequested, watchFetch<%= classify(name) %>DetailSuccessed];
