import * as _ from 'lodash';
import { Component, OnInit } from '@angular/core';
import { Router, NavigationEnd } from '@angular/router';
import { <%= actionGenerator('FETCH_ALL', 'REQUESTED') %> } from './list.actions';
import { <%= actionGenerator('DELETE', 'REQUESTED') %> } from '../edit/edit.actions';
import { BaseComponent } from '<%= resolveRelativePath('src/app/components/base.component', generateFilePath(`${dasherize(name)}/list/list.component.ts`)) %>';

@Component({
  selector: 'app-list',
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.<%= styleext %>']
})
export class ListComponent extends BaseComponent implements OnInit {
  public reducer: String = '<%= fullReducerGenerator('list') %>';

  constructor(private router: Router) {
    super();
    this.navigationSubscription = this.router.events.subscribe((e: any) => {
      if (e instanceof NavigationEnd) {
        this.dispatch({ type: <%= actionGenerator('FETCH_ALL', 'REQUESTED') %>, data: this.queryParser.parse(['name']) });
      }
    });
  }

  ngOnInit() {
    this.init();
  }

  delete(id) {
    this.store.dispatch({ type: <%= actionGenerator('DELETE', 'REQUESTED') %>, data: id });
  }

  mapStateToProps(state) {
    return {
      payload: state.<%= fullReducerGenerator('list') %>
    };
  }

  mapDispatchToProps(dispatch) {
    return {
      dispatch
    };
  }
}
