import * as _ from 'lodash';
import { Component, OnInit } from '@angular/core';
import { Router, NavigationEnd } from '@angular/router';
import { BaseComponent } from '<%= resolveRelativePath('src/app/components/base.component', generateFilePath(`${dasherize(name)}/${dasherize(name)}.component.ts`)) %>';

@Component({
  selector: 'app-<%= dasherize(name) %>',
  templateUrl: './<%= dasherize(name) %>.component.html',
  styleUrls: ['./<%= dasherize(name) %>.component.<%= styleext %>']
})
export class <%= classify(name) %>Component extends BaseComponent implements OnInit {
  public reducer: String = '<%= fullReducerGenerator() %>';

  constructor(private router: Router) {
    super();
    this.navigationSubscription = this.router.events.subscribe((e: any) => {
      if (e instanceof NavigationEnd) {
        // dispatch an action
      }
    });
  }

  ngOnInit() {
    this.init();
  }

  mapStateToProps(state) {
    return {
      payload: state.<%= fullReducerGenerator() %>
    };
  }

  mapDispatchToProps(dispatch) {
    return {
      dispatch
    };
  }
}
