import { ComponentGenerator } from './Generators/ComponentGenerator/ComponentGenerator';
import { Rule } from '@angular-devkit/schematics';
import { EmptyModuleGenerator } from './Generators/EmptyModuleGenerator/EmptyModuleGenerator';
import { SingleGenerator } from './Generators/SingleGenerator/SingleGenerator';
import { AdminUserComponentGenerator } from './Generators/AdminUserComponentGenerator/AdminUserComponentGenerator';

export default function(options: any): Rule {
  switch (options.type) {
    case 'component':
      return new ComponentGenerator().generate(options);
    case 'module':
      return new EmptyModuleGenerator().generate(options);
    case 'single':
      return new SingleGenerator().generate(options);
    case 'user-management':
      return new AdminUserComponentGenerator().generate(options);
    default:
      return new ComponentGenerator().generate(options);
  }
}
